
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using UnityEngine;
using System.Net;
using System.Net.Sockets;
//using Mono.Zeroconf;
//namespace Mono.Zeroconf
namespace CCPConnector
{
	
	[KSPAddon(KSPAddon.Startup.EveryScene, true)]
	//[KSPAddon(KSPAddon.Startup.Flight, false)]
	public class CCPConnector : MonoBehaviour
	{
		
//---------------------------------------------------------------------		
//                    Variable declaration
//---------------------------------------------------------------------			
// might find other tossed around the code, but should not be very important ;) ... 
		
		// Status
		int defaultMessages = 50;
		public static bool connectedToCCP;
		public static bool portSetted ;
		public static int wantedPort;
		public static string status = "CONSOLE";
		bool sendBasicData;
	
		public static string appChannelIdentifier = "KSP";
		bool sceneCheck = false;
		
		bool highlander = true; // will it survive scene loads ? Remeber to change KSPAddon bool value accordingly 
		public GameScenes actualScene;
		// CCP  "message" class, this is the object we will use to communicate with CCP Server app.
		public static  Socket suck;
		
		public static KCCPPacket[] mainMessages;
		static private bool dataLock;
		private static List<KCCPPacket> tmpMsgArr;
		
		// simple send rate handling
		public static float sendRate = 0.5f;
		private float nextSendTime;	
		
		static bool ready;
		public static bool debugMode = false;
		// BASIC DATA VARIABLES
		// Values i want to to read from KSP and send to CCP 	
		// using string so don't need to convert from double, triple , single or whatever else kind of var...
		

		
		private bool vChangeDelegate;
//---------------------------------------------------------------------		
//             		INITIALIZATION
//---------------------------------------------------------------------				
		public void OnGUI() {
			KSPCCPDataHandler.OnGUI();	
		}
		public void Awake() {	
			Debug.Log(">>>>>>>>>>>>>>>>>>>>>Good Morning ! I'm Awake ! (frozen)<<<<<<<<<<<<<<<<<<<<< " );
			if (highlander)
				DontDestroyOnLoad(this);
			CHSetup();
			
			KSPCCPDataHandler.Setup();
		}
		
		public void OnLevelWasLoaded() {
			Debug.Log("Frozen OnLevelWasLoaded");
			actualScene = HighLogic.LoadedScene ;
			KSPCCPDataHandler.OnLevelWasLoaded();
			//KSPDataHandler.OnLevelWasLoaded();
			
		}
		public void Start() {
			KSPCCPDataHandler.Start();
		}
	
		public void CHSetup() {
			mainMessages = new KCCPPacket[defaultMessages]; 
			
			ready = true;
			
			KSPCCPDataHandler.SetupBasicDataMessages();
		}
		
//---------------------------------------------------------------------		
//                  GUI window code 
//---------------------------------------------------------------------			
		
//---------------------------------------------------------------------		
//         Update , data handling, a bit of everything
//---------------------------------------------------------------------				
	
		void Update() {
			KSPCCPDataHandler.FUpdate();
		}
		
		public void LateUpdate() {
			
			SendData();	
		}

		public void SendData() {
			if (!connectedToCCP)
	    		return;
			
			if (suck != null && suck.Connected && !dataLock) {
				if (mainMessages == null || mainMessages.Length == 0)
					return;
				for (int i = 0; i < mainMessages.Length; i++) {
					if (mainMessages[i] != null && mainMessages[i].active && mainMessages[i].sceneType == actualScene) {
						mainMessages[i].Communicate(suck);
					}
				}
			}	
		}
		
		public static void Connect() {
			if (connectedToCCP)
				return;
			if (!portSetted) {
				status = "port not setted";	
				return;
			}	
			status = "Starting Connection";
	
			suck = new Socket(AddressFamily.InterNetwork,SocketType.Stream,ProtocolType.Tcp);	
			IPAddress ip = IPAddress.Parse("127.0.0.1");
			IPEndPoint ep = new IPEndPoint(ip,wantedPort);
	
			SetupMessagesForConnection();
			
			suck.Connect( ep);	
			if (suck.Connected) {
				//suck.Send(bytes,bytes.length, 0 );	
				connectedToCCP = true;
				Debug.Log("endPoint = " + suck.LocalEndPoint.ToString());
				status = "Connected";
				status ="endPoint = " + suck.LocalEndPoint.ToString();
				Debug.Log("Frozen YES !!!!!! WE ARE CONNECTED !!!!");
			}
			else {
				status = "hem... couldn't connect";	
			}	
		}
		
		public static void Disconnect() {
			if (suck != null)
				suck.Disconnect(false);
			connectedToCCP = false;
		}
		
		void OnDestroy() {
			Disconnect();
		}
		
//---------------------------------------------------------------------		
//             		Messages operations
//---------------------------------------------------------------------				
		
		
		public static void SetupMessagesForConnection() {
			for (int i = 0; i < mainMessages.Length; i++) {
				if (mainMessages[i] != null) {
					mainMessages[i].SetMasterCHId(appChannelIdentifier);
					mainMessages[i].sendRate = sendRate;
				}
			}
		}
		
		public static bool ForceMessageAtId(CCPMessageType type,int id) {
			int i;
			if (mainMessages != null) {
				if ( id >= mainMessages.Length) {
					tmpMsgArr = new List<KCCPPacket>(mainMessages);
					int wL = (id +1) - mainMessages.Length;

					for (  i = 0;i < wL ;i++) {
						tmpMsgArr.Add(null);
					}
					mainMessages = tmpMsgArr.ToArray();
					
				}
				else {
					// Nothing to do here, final procedure is enough
					
				}
				
			}	
			else {
				tmpMsgArr = new List<KCCPPacket>();
				for ( i = 0; i < id+1;i++) {
					tmpMsgArr.Add(null);	
				}
				mainMessages = tmpMsgArr.ToArray();
			}
			
			KCCPPacket tmp = new KCCPPacket(id);
			tmp.type = type;
			tmp.SetMasterCHId(appChannelIdentifier);
			mainMessages[id] = tmp;
			return true;
		}
		
		public static int RegisterMessage(CCPMessageType type,GameScenes sc) {
		//	dataLock = true;
			int id = 0;
			if (mainMessages != null) {
				id = mainMessages.Length;
				tmpMsgArr = new List<KCCPPacket>(mainMessages);	
			}	
			else
				tmpMsgArr = new List<KCCPPacket>();
			
			KCCPPacket tmp = new KCCPPacket(id);
			tmp.type = type;
			tmp.sceneType = sc;
			tmp.SetMasterCHId(appChannelIdentifier);
			tmpMsgArr.Add(tmp);
			mainMessages = tmpMsgArr.ToArray();
		//	dataLock = false;
			return id;
		}
		
		// if they return false it can mean that the channel is not active, found, protected, nice in general etc..
		public static bool SetCHSendRate(int id, float vl) {
			KCCPPacket pk =   GetCH( id,false);
			if (pk != null) {
				pk.sendRate =vl;
				return true;
			}	
			return false;	
		}
		
		public static bool SetChValue(int id,String str, int vl, int min,int max) {
			KCCPPacket pk =   GetCH( id,true);
			if (pk != null) {
				pk.min = min;
				pk.max = max;
				pk.valInt =vl;
				pk.valString = str;
				return true;
			}	
			return false;
		}
		
		public static bool SetChValue(int id, int vl, int min,int max) {
			KCCPPacket pk =   GetCH( id,true);
			if (pk != null) {
				pk.min = min;
				pk.max = max;
				pk.valInt =vl;
				return true;
			}	
			return false;
		}
		
		public static bool SetCHValue(int id,string vl) {
			return SetCHValue(id,vl,false);
		}	
		
		public static bool SetCHValue(int id,string vl,bool security) {
			KCCPPacket pk =   GetCH( id,security);
			if (pk != null) {
				pk.valString =vl;
				return true;
			}	
			return false;
		}
		
		public static bool SetCHValue(int id,int vl) {
			return SetCHValue(id,vl,false);
		}	
		public static bool SetCHValue(int id,int vl,bool security) {
			KCCPPacket pk =   GetCH( id,security);
			if (pk != null) {
				pk.valInt =vl;
				return true;
			}	
			return false;
		}
		
		// customly set the status 
		public static bool ToggleCH(int id , bool st) {
			KCCPPacket pk =   GetCH( id,false);
			if (pk != null) {
				pk.active = st;
				return pk.active;
			}	
			return false;
		}
		
		// simple switches status from on to off and vice versa.
		public static  bool ToggleCH(int id) {
			KCCPPacket pk =   GetCH( id,false);
			if (pk != null) {
				pk.active = !pk.active;
				return pk.active;
			}	
			return false;
		}
		
		public static bool CommunicateCH(int id) {
			return CommunicateCH(id,false);
		}
		public static bool CommunicateCH(int id, bool security) {
			if (!connectedToCCP || suck == null || !suck.Connected || dataLock)
				return false;

			KCCPPacket pk =   GetCH( id,security);
			if (pk != null) {
				pk.Communicate(suck);
				return true;
			}	
			else
				return false;

		}
		
		public static KCCPPacket GetCH(int id) {
			return GetCH(id,false);	
		}	
		
		public static KCCPPacket GetCH(int id,bool security) {
			if (id >= mainMessages.Length || id < 0) 
				return null;
			if (mainMessages[id] != null && (!mainMessages[id].cPrivate || security == true)) {
				return mainMessages[id];
			}		
			else 
				return null;
		}

		
//---------------------------------------------------------------------		
//                     INPUT ?
//---------------------------------------------------------------------		
		public void ReadInput() {
			
			KSPCCPDataHandler.ReadInput();
			
		}

		

//---------------------------------------------------------------------		
//             BONJOUR auto find integrations  tests... 
// YES ksp 0.21 brought System.IO back !!! Cool, bonjour auto discovery might have a chance !
//---------------------------------------------------------------------
	//private  uint @interface = 0;
   	//private  AddressProtocol address_protocol = AddressProtocol.Any;
	//public IEnumerator<IResolvableService> services;		
    private  string domain = "local";	
	public bool resolve_shares;	
	void Test() {
			Debug.Log(">>>> TEST <<<<");	
			//string type = "_workstation._tcp";
			//ServiceBrowser browser = new ServiceBrowser();
            //browser.ServiceAdded += OnServiceAdded;
           // browser.ServiceRemoved += OnServiceRemoved;
           // browser.Browse (@interface, address_protocol, type, domain);
			//services = browser.GetEnumerator();
		}	
	/*	
	private  void OnServiceAdded(object o, ServiceBrowseEventArgs args) {
       	 Debug.Log("*** Found name = "+args.Service.Name +", type = " + args.Service.RegType+", domain = "+args.Service.ReplyDomain);
        
        if(resolve_shares) {
            args.Service.Resolved += OnServiceResolved;
            args.Service.Resolve();
        }
    }
		
	private  void OnServiceRemoved(object o, ServiceBrowseEventArgs args)  {        
        Debug.Log("*** Lost  name = "+args.Service.Name+", type = "+ args.Service.RegType+", domain = "+ args.Service.ReplyDomain);    
    }
		
	   private  void OnServiceResolved(object o, ServiceResolvedEventArgs args)
    {
      	IResolvableService service = o as IResolvableService;
        Debug.Log ("*** Resolved name = "+service.FullName+", host ip = "+ service.HostEntry.AddressList[0]+", hostname = "+service.HostEntry.HostName+", port = "+service.Port+", " + 
            "interface = "+ service.NetworkInterface+", address type = "+service.AddressProtocol);
        
        ITxtRecord record = service.TxtRecord;
        int record_count = record != null ? record.Count : 0;
        if(record_count > 0) {
            Debug.Log(", TXT Record = [");
            for(int i = 0, n = record.Count; i < n; i++) {
                TxtRecordItem item = record.GetItemAt(i);
               Debug.Log(""+ item.Key+"_ " +item.ValueString);
                if(i < n - 1) {
                    Debug.Log(", ");
                }
            }
            Debug.Log("]");
        } else {
            Debug.Log("");
        }
    }
    */
    	
	
	}
	
}



