
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using UnityEngine;
using System.Net;
using System.Net.Sockets;

namespace CCPConnector
{
	[KSPAddon(KSPAddon.Startup.EveryScene, true)]
	public class KSPCCPDataHandler : MonoBehaviour
	{
		
		static bool sceneCheck;
		static bool printStatus = true;
		static bool flightDataSend = false;
		private static float resSendLastTime;
		public static float resSendRate = 0.1f;

		
		
		static string vesselName = "";
		static string acceleration = "";
		static string speed = "";
		static string actualThrottle = "";
		static string altitude = "";
		static string verticalSpeed = "";
		static string horizontalSurfaceSpeed = "";
		static string actualTimeWarp = "";
		static string actualMissionTime ="";
		static string actualTime = "";
		static string timeToApo = "";
		static string timeToPeri = "";
		static string bodyInfo = "";
		static string vesselInfo = "";
		static string infoPanelSString ="";
		static string infoPanelTitle = "";
		static string timeToManouver ="";
		
		static int precisionModeStatus ;
		static int sasStatus;
		
		static int infoPanelIndex;
		static bool sendInfoPanel = true ;
		static bool sendSeparateInfos = false;
		static HighLogic highLogic;
		static FlightInputHandler flightInputHandler;
		static FlightUIController flightUIController;
		
		
		static bool handleElectricCharge = true;
		static bool handleFuel = true;
		static bool handleRcs = true;
		static bool handleAirIntake = true;
		
		
		static double vSpeed ;
		static bool rcsStatus;
		static double gees;
		static double ovSpeed;
		static bool nodesPresent;
		static double actualUT;
		static double actualTT;
		
		static double ePower = 0.0f;
        static double ePowerMx = 0.0f;
          
		static double oairIntake = 0.0f;	
		static double airIntake = 0.0f;
		static double airIntakeMx = 0.0f;
	
		static double fuel = 0.0f;
        static double fuelMx = 0.0f;
		static double solidFuel = 0.0f;
		static double solidFuelMx = 0.0f;
        static double oxidizer = 0.0f;
		static double oxidizerMx = 0.0f;
		static double monoPropellant = 0.0f;
		static double monoPropellantMx = 0.0f;
		
		static double csLiquidFuel = 0.0f;
		static double csLiquidFuelMx = 0.0f;
		
		static double csSolidFuel = 0.0f;
		static double csSolidFuelMx = 0.0f;
		
		static double csOxidizer = 0.0f;
		static double csOxidizerMx = 0.0f;
		
		
		public static double dVForNode;
		public static string dvToNodeS;
		
		public static void Test() {
			Debug.Log("Frozen KSPCCPDataHandler  TEST !!!");	
		}
		//  GUI  
		
		static Rect windowRect  = new Rect (20, 20, 320, 290);
		static Rect warningWindowRect = new Rect(20, 20, 320, 120);
		static string portField = "Port number"; // hem... GUILayout. doesn't like numbers... so will have to pass through this...
		static bool guiMaximized;
		static Rect ui_icon_pos = new Rect((Screen.width / 2) - 320, Screen.height - 22, 40, 20);
		static bool hideMainButton = false;
		static bool warningDisplayed = false;
		
		public static void OnGUI() {
			if (!sceneCheck)
				return;
			
			GUI.skin = HighLogic.Skin;
			if (!hideMainButton) {
				if ( GUI.Button(ui_icon_pos, "CCP", GUI.skin.button)) {
					guiMaximized = !guiMaximized;
					windowRect.x = (Screen.width/2) - (windowRect.width/2);
					windowRect.y = (Screen.height/2) - (windowRect.height/2);
				}
			}
			if (guiMaximized)
				windowRect = GUI.Window (0, windowRect, MainWindowShow, "KSP tp CCP");
			if (warningDisplayed) {
				warningWindowRect.x = (Screen.width/2) - (windowRect.width/2);
				warningWindowRect.y = (Screen.height/2) - (windowRect.height/2);
				warningWindowRect = GUI.Window(0,warningWindowRect,WarningWindowShow,"CCP WARNING");
			}
		}
		public static void WarningWindowShow(int id) {
			GUILayout.BeginHorizontal();
				GUILayout.Label("To show again the CCP button, press K on your keyboard");
			GUILayout.EndHorizontal();
			if (GUILayout.Button("OK, got it")) {
				warningDisplayed = false;
				hideMainButton = true;
			}
		}
		
		public static void MainWindowShow(int id) {
			GUILayout.BeginVertical();
				GUILayout.BeginHorizontal("Box");
					GUILayout.Label("App id : ");
					CCPConnector.appChannelIdentifier = GUILayout.TextField(CCPConnector.appChannelIdentifier,30);
				GUILayout.EndHorizontal();
				GUILayout.BeginHorizontal("Box");
					//resolve_shares = GUILayout.Toggle(resolve_shares,"resolve shares");
					GUILayout.Label("Port : ");
					portField = GUILayout.TextField(portField,6,GUILayout.Width(70));
					//sendBasicData = GUILayout.Toggle(sendBasicData,"Send Basic Data");
					
				GUILayout.EndHorizontal();
				
				GUILayout.BeginHorizontal();
				sendInfoPanel = GUILayout.Toggle(sendInfoPanel,"Send Infos");
				GUILayout.EndHorizontal();
				GUILayout.BeginHorizontal();
				sendSeparateInfos = GUILayout.Toggle(sendSeparateInfos,"Send Sep infos");
				GUILayout.EndHorizontal();
				GUILayout.BeginHorizontal("Box");
					GUILayout.Label("Send Rate : " + FTools.ShortenValue(""+CCPConnector.sendRate,5) );
					CCPConnector.sendRate =  GUILayout.HorizontalSlider(CCPConnector.sendRate, 0.05f, 2.0f);
				GUILayout.EndHorizontal();
			
				if (int.TryParse(portField,out CCPConnector.wantedPort)) {
					CCPConnector.portSetted = true;
				}	
				else {
					CCPConnector.portSetted = false;
				}
				
				//debugMode = GUILayout.Toggle(debugMode,"debug");
				if (!CCPConnector.connectedToCCP) {
					if (GUILayout.Button("Connect")) 
						CCPConnector.Connect();
				}
				else {
					if (GUILayout.Button("Disconnect")) 
						CCPConnector.Disconnect();	
				}
					
				if (printStatus) {
					GUILayout.BeginHorizontal("Box");
						GUILayout.Label(CCPConnector.status);
					GUILayout.EndHorizontal();
				}
				GUILayout.BeginHorizontal();
				if (GUILayout.Button("Close")) {
					guiMaximized = false;
				}	
				if (GUILayout.Button("Close and hide") ) {
					guiMaximized = false;
					warningDisplayed = true;
				}
				GUILayout.EndHorizontal();
			GUILayout.EndVertical();
			GUI.DragWindow();	
		}
		
		// END OF GUI !
		
		
		public static void Setup()  {
			Debug.Log("Frozen KSPDataHandler Awake");
			//DontDestroyOnLoad(this);
			
		}
		
		// Setups etc 
		public static void OnLevelWasLoaded() {
			Debug.Log("Frozen KSPDataHandler OnLevelWasLoaded");

			//flightUIController = FlightUIController.fetch;	
			LateSetup();
			//Invoke("LateSetup",1.0f);
		}
		public static void Start() {
			LateSetup();
			Debug.Log("Frozen KSPDataHandler Start");
			//Invoke("LateSetup",1.0f);
		}
		public static void LateSetup() {
			
			SceneCheck();
			if (!sceneCheck)
				return;
			
			highLogic = HighLogic.fetch;
			flightInputHandler = FlightInputHandler.fetch;
			flightUIController = FlightUIController.fetch;
			if (flightInputHandler == null)
				flightInputHandler = (FlightInputHandler) UnityEngine.Object.FindObjectOfType(typeof(FlightInputHandler));
			
			if ( flightInputHandler == null) {
					Debug.Log("CCP NO flightInputHandler	!!");
				
			}
			if ( highLogic == null) {
				Debug.Log("CCP NO highLogic	!!");	
			}
			if ( flightUIController == null) {
				Debug.Log("CCP NO flightUIController	!!");	
			}
			
		}
		
		
		
		public static void   SceneCheck(){
			Debug.Log("Frozen SceneCheck 1");
			
			if (HighLogic.LoadedScene != GameScenes.SPACECENTER && HighLogic.LoadedScene != GameScenes.FLIGHT)
				sceneCheck = false;
			else {
				sceneCheck = true;
				if (HighLogic.LoadedScene == GameScenes.FLIGHT) {
					flightDataSend = true;
						
				}
				else
					flightDataSend = false;
			}	
			Debug.Log("Frozen SceneCheck 2 sceneCheck = " + sceneCheck + " GameInfo.gameScene =" + GameInfo.gameScene);
		}
		
		public static  void SetupBasicDataMessages() {
		// basic messages initialization.
		
			CCPConnector.mainMessages[0] = new KCCPPacket((int)0,CCPMessageType.String,GameScenes.FLIGHT);
			CCPConnector.mainMessages[1] = new KCCPPacket((int)1,CCPMessageType.String,GameScenes.FLIGHT);
			CCPConnector.mainMessages[2] = new KCCPPacket((int)2,CCPMessageType.Value,GameScenes.FLIGHT);
			//mainMessages[2].debug = true;
			CCPConnector.mainMessages[3] = new KCCPPacket((int)3,CCPMessageType.String,GameScenes.FLIGHT);
			CCPConnector.mainMessages[4] = new KCCPPacket((int)4,CCPMessageType.String,GameScenes.FLIGHT);
			CCPConnector.mainMessages[5] = new KCCPPacket((int)5,CCPMessageType.Value,GameScenes.FLIGHT);
			CCPConnector.mainMessages[6] = new KCCPPacket((int)6,CCPMessageType.String,GameScenes.FLIGHT);
			//mainMessages[6].debug = true;
			CCPConnector.mainMessages[7] = new KCCPPacket((int)7,CCPMessageType.String,GameScenes.FLIGHT);
			//mainMessages[7].debug = true;
			
			//main panel content
			CCPConnector.mainMessages[8] = new KCCPPacket((int)8,CCPMessageType.String,GameScenes.FLIGHT);
			//main panel title
			CCPConnector.mainMessages[9] = new KCCPPacket((int)9,CCPMessageType.String,GameScenes.FLIGHT);
			
			// separate info channels
			// vessel
			CCPConnector.mainMessages[10] = new KCCPPacket((int)10,CCPMessageType.String,GameScenes.FLIGHT);
			// orbit
			CCPConnector.mainMessages[11] = new KCCPPacket((int)11,CCPMessageType.String,GameScenes.FLIGHT);
			// body
			CCPConnector.mainMessages[12] = new KCCPPacket((int)12,CCPMessageType.String,GameScenes.FLIGHT);
			
			// electricCharge
			CCPConnector.mainMessages[13] = new KCCPPacket((int)13,CCPMessageType.RangeValue,GameScenes.FLIGHT);
			CCPConnector.SetCHSendRate(13, resSendRate) ;
			// liquidFuel
			CCPConnector.mainMessages[14] = new KCCPPacket((int)14,CCPMessageType.RangeValue,GameScenes.FLIGHT);
			CCPConnector.SetCHSendRate(14, resSendRate) ;
			// oxidizer
			CCPConnector.mainMessages[15] = new KCCPPacket((int)15,CCPMessageType.RangeValue,GameScenes.FLIGHT);
			CCPConnector.SetCHSendRate(15, resSendRate) ;
			// monoProp
			CCPConnector.mainMessages[16] = new KCCPPacket((int)16,CCPMessageType.RangeValue,GameScenes.FLIGHT);
			CCPConnector.SetCHSendRate(16, resSendRate) ;
			// airIntake
			CCPConnector.mainMessages[17] = new KCCPPacket((int)17,CCPMessageType.RangeValue,GameScenes.FLIGHT);
			CCPConnector.SetCHSendRate(17, resSendRate) ;
			
			// Current stage liquid fuel
			CCPConnector.mainMessages[18] = new KCCPPacket((int)18,CCPMessageType.RangeValue,GameScenes.FLIGHT);
			CCPConnector.SetCHSendRate(18, resSendRate) ;
			// Current stage Oxidizer
			CCPConnector.mainMessages[19] = new KCCPPacket((int)19,CCPMessageType.RangeValue,GameScenes.FLIGHT);
			CCPConnector.SetCHSendRate(19, resSendRate) ;
			
			// Vertical Speed
			CCPConnector.mainMessages[20] = new KCCPPacket((int)20,CCPMessageType.RangeValue,GameScenes.FLIGHT);
			//SetCHSendRate(20, resSendRate) ;
			// Gee force
			CCPConnector.mainMessages[21] = new KCCPPacket((int)21,CCPMessageType.RangeValue,GameScenes.FLIGHT);
			// RCS Status
			CCPConnector.mainMessages[22] = new KCCPPacket((int)22,CCPMessageType.Value,GameScenes.FLIGHT);
			
			// Time to Apo
			CCPConnector.mainMessages[23] = new KCCPPacket((int)23,CCPMessageType.String,GameScenes.FLIGHT);
			// Time to Peri
			CCPConnector.mainMessages[24] = new KCCPPacket((int)24,CCPMessageType.String,GameScenes.FLIGHT);
			// Time to Manouver node
			CCPConnector.mainMessages[25] = new KCCPPacket((int)25,CCPMessageType.String,GameScenes.FLIGHT);
			
			// General SolidFuel 
			CCPConnector.mainMessages[26] = new KCCPPacket((int)26,CCPMessageType.RangeValue,GameScenes.FLIGHT);
			CCPConnector.SetCHSendRate(26, resSendRate) ;
			// Current stage SolidFuel
		
			CCPConnector.mainMessages[27] = new KCCPPacket((int)27,CCPMessageType.RangeValue,GameScenes.FLIGHT);
			CCPConnector.SetCHSendRate(27, resSendRate) ;
			
			// Resources info panel
			CCPConnector.mainMessages[28] = new KCCPPacket((int)28,CCPMessageType.String,GameScenes.FLIGHT);
			CCPConnector.SetCHSendRate(28, resSendRate) ;
			
			// DV to node 
			CCPConnector.mainMessages[29] = new KCCPPacket((int)29,CCPMessageType.String,GameScenes.FLIGHT);
			CCPConnector.SetCHSendRate(29, resSendRate) ;
			
			// Speed type
			CCPConnector.mainMessages[30] = new KCCPPacket((int)30,CCPMessageType.String,GameScenes.FLIGHT);
			CCPConnector.SetCHSendRate(30, 0.5f) ;
		
			
		}
		
		
		public static void ReadInput() {
			if (Input.GetKey(KeyCode.K))
				hideMainButton = !hideMainButton;
			
			if (Input.GetKey(KeyCode.KeypadDivide)) {
				PrevInfoPanel();	
			}
			if (Input.GetKey(KeyCode.KeypadMultiply)) {
				NextInfoPanel();	
			}
		}
		private static float iPT = 0.0f;
		public static void NextInfoPanel() {
			if (Time.time < iPT)
				return;
			iPT = Time.time + 0.3f;
			infoPanelIndex ++;
			if (infoPanelIndex >3)
				infoPanelIndex = 0;
		}
		public static void PrevInfoPanel() {
			if (Time.time < iPT)
				return;
			iPT = Time.time + 0.2f;
			infoPanelIndex --;
			if (infoPanelIndex <0)
				infoPanelIndex = 3;
		}

		
		void VesselChange() {
			//SetupGas();	
		}
		public static void FUpdate() {
			if (!flightDataSend)
				return;
			// might need to handle scene detection etc...
			
			HandleResources();
			ReadFlightData();
			ReadInput();
		}
		
		private static int dCnt;
		private static List<int> activeEnginesStages;
		public static void HandleResources() {
			if (Time.time < resSendLastTime + resSendRate) 
				return;
			resSendLastTime = Time.time;
			Vessel v = FlightGlobals.ActiveVessel;
			
			 ePower = 0.0f;
             ePowerMx = 0.0f;
          	 oairIntake = 0.0f;
			 airIntake = 0.0f;
			 airIntakeMx = 0.0f;
		
			 fuel = 0.0f;
             fuelMx = 0.0f;
			 solidFuel = 0.0f;
			 solidFuelMx = 0.0f;
			
             oxidizer = 0.0f;
			 oxidizerMx = 0.0f;
			 monoPropellant = 0.0f;
			 monoPropellantMx = 0.0f;
			
			 csLiquidFuel = 0.0f;
			 csLiquidFuelMx = 0.0f;
			 csSolidFuel = 0.0f;
			 csSolidFuelMx = 0.0f;
			
			 csOxidizer = 0.0f;
			 csOxidizerMx = 0.0f;
			// check for decouplers
			int hDec = 0;
			activeEnginesStages = new List<int>();
			double tmpCsFuel = 0;
			List<PartResource> allCurrentRes = new List<PartResource> ();
			foreach (Part pd in v.parts) {
				if (pd.State == PartStates.ACTIVE && FTools.isEngine(pd)) {
						//Debug.Log("active engine detected , stage = " + pd.inverseStage + "original = " +pd.originalStage + " defINvertStage = " + pd.defaultInverseStage);
						if (!activeEnginesStages.Contains(pd.inverseStage)) {
							activeEnginesStages.Add((int) pd.inverseStage);
						}
						if (!activeEnginesStages.Contains(pd.defaultInverseStage))
							activeEnginesStages.Add((int) pd.defaultInverseStage);
						foreach (PartModule pm in pd.Modules)
                    		{
                        		if ((pm is ModuleEngines) && (pm.isEnabled)) 
                        			{
                         				using (List<ModuleEngines.Propellant>.Enumerator enumerator =((ModuleEngines) pm).propellants.GetEnumerator ())
									{
										while (enumerator.MoveNext ())
										{
												ModuleEngines.Propellant current = enumerator.Current;
												
												List<PartResource> list = new List<PartResource> ();
						
												pd.GetConnectedResources (current.id, list);
												foreach (PartResource pz in list)
	            								{
													if (!allCurrentRes.Contains(pz))
														allCurrentRes.Add(pz);
												}
										}
                        			}
                   			 }
						}
				}
				/*
				if (FTools.isDecoupler(pd) &&  pd.isAttached) {
					if (CCPConnector.debugMode)
						Debug.Log("decoupler detected , stage = " + pd.inverseStage);
					if (pd.inverseStage > hDec)
						hDec = pd.inverseStage;
				}
				*/
			}
			foreach (PartResource pzr in allCurrentRes)
	        {
				if (pzr.resourceName.Equals("LiquidFuel")) {
					csLiquidFuel += pzr.amount;
					csLiquidFuelMx += pzr.maxAmount;
				}
				if (pzr.resourceName.Equals("Oxidizer")) {
					csOxidizer += pzr.amount;
					csOxidizerMx += pzr.maxAmount;
				}
				if (pzr.resourceName.Equals("SolidFuel")) {
					csSolidFuel += pzr.amount;
					csSolidFuelMx += pzr.maxAmount;
				}
			}
			//if (activeEnginesStages.Length() > 0)
			//Debug.Log("dactiveEnginesStages.Count  = " + activeEnginesStages.Count() + " tmpCsFuel = " + tmpCsFuel);
	        foreach (Part p in v.parts)
	            {
		            foreach (PartResource pr in p.Resources)
		            {
						if (!p.isAttached)
							continue;
						if (handleElectricCharge) { 
							if (pr.resourceName.Equals("ElectricCharge"))
			                {
			                    ePower += pr.amount;
			                    ePowerMx += pr.maxAmount;
			                }
						}
						
						if (handleFuel) {
			                if (pr.resourceName.Equals("LiquidFuel"))
			                {
			                    fuel += pr.amount;
								fuelMx += pr.maxAmount;
							
								
								if (CCPConnector.debugMode) {
									
									//Debug.Log("hDec = "+hDec+" Staging.CurrentStage = " + Staging.CurrentStage + "\n p.name = " + p.name + "\n" + "childStageOffset = " + p.childStageOffset + "\n manualStageOffset = " + p.manualStageOffset + " \n defaultInverseStage = " + p.defaultInverseStage + "\n inverseStage = " + p.inverseStage + "\n inStageIndex = " + p.inStageIndex + "\n originalStage = " +p.originalStage);

								}
								/*
								if ((p.State == PartStates.ACTIVE) || (p.inverseStage >= Staging.CurrentStage) || activeEnginesStages.Contains((int) p.inverseStage) )
							//	if (p.inverseStage >= Staging.CurrentStage) 
								{
									//csLiquidFuel += pr.amount;
									//csLiquidFuelMx += pr.maxAmount;
								}
								*/
			                }
							if (pr.resourceName.Equals("SolidFuel"))
			                {
			                    solidFuel += pr.amount;
								solidFuelMx += pr.maxAmount;
								/*
								if (p.inverseStage >= Staging.CurrentStage) 
								{
									//csSolidFuel += pr.amount;
									//csSolidFuelMx += pr.maxAmount;
								}
								*/
			                }
							if (pr.resourceName.Equals("Oxidizer"))
			                {
			                    oxidizer += pr.amount;
			                    oxidizerMx += pr.maxAmount;
			               		/*
								if (p.inverseStage >= Staging.CurrentStage) 
								{
									//csOxidizer += pr.amount;
									//csOxidizerMx += pr.maxAmount;
								}
								*/
			                }
							if (pr.resourceName.Equals("MonoPropellant"))
			                {
			                    monoPropellant += pr.amount;
			                    monoPropellantMx += pr.maxAmount;
			                }
						}
					
						if (handleAirIntake) {
							if (pr.resourceName.Equals("IntakeAir"))
			                {
			                    oairIntake += pr.amount;
			                    airIntakeMx += pr.maxAmount;
			                }
						}
		            }
	            }
			    airIntake= oairIntake;
				airIntake *= 100.0f;
				airIntakeMx *= 100.0f;
		
				CCPConnector.SetChValue(13,FTools.ShortenValue(""+ePower,1) ,(int) Math.Round((double)ePower), (int)Math.Round((double)0),(int) Math.Round((double)ePowerMx)) ;
				CCPConnector.SetChValue(14,FTools.ShortenValue(""+fuel,1), (int) Math.Round((double)fuel), (int)0,(int) Math.Round((double)fuelMx)) ;
				CCPConnector.SetChValue(15,FTools.ShortenValue(""+oxidizer,1), (int) Math.Round((double)oxidizer), (int)0,(int) Math.Round((double)oxidizerMx)) ;
				CCPConnector.SetChValue(16,FTools.ShortenValue(""+monoPropellant,1),  (int) Math.Round((double)monoPropellant), (int)0,(int) Math.Round((double)monoPropellantMx)) ;
				CCPConnector.SetChValue(17,FTools.ShortenValue(""+oairIntake,3),(int) Math.Round((double)airIntake), (int)0,(int) Math.Round((double)airIntakeMx)) ;
				CCPConnector.SetChValue(26,FTools.ShortenValue(""+solidFuel,1), (int) Math.Round((double)solidFuel), (int)0,(int) Math.Round((double)solidFuelMx)) ;
			
				CCPConnector.SetChValue(18,FTools.ShortenValue(""+csLiquidFuel,1),(int) Math.Round((double)csLiquidFuel), (int)0,(int) Math.Round((double)csLiquidFuelMx)) ;
				CCPConnector.SetChValue(19,FTools.ShortenValue(""+csOxidizer,1),(int) Math.Round((double)csOxidizer), (int)0,(int) Math.Round((double)csOxidizerMx)) ;
				CCPConnector.SetChValue(27,FTools.ShortenValue(""+csSolidFuel,1), (int) Math.Round((double)csSolidFuel), (int)0,(int) Math.Round((double)csSolidFuelMx)) ;
				/*
				if (CCPConnector.debugMode) {
					if (dCnt > 3) {
						Debug.Log("csLiquidFuel = " + csLiquidFuel + "     /     " + csLiquidFuelMx);
						Debug.Log("csSolidFuel = " + csSolidFuel + "     /     " + csSolidFuelMx);
						Debug.Log("solidFuel = " + solidFuel + "     /     " + solidFuelMx);
						dCnt = 0;
					}
					dCnt++;
				}
				*/
		}
		
		/*
		this.alt.setValue (FlightGlobals.ActiveVessel.altitude);
		this.gee.setValue (FlightGlobals.ActiveVessel.geeForce);
		this.vs.setValue (FlightGlobals.ActiveVessel.verticalSpeed);
		this. = FlightGlobals.ActiveVessel.altitude;
		this.thr.setValue (FlightGlobals.ActiveVessel.ctrlState.mainThrottle);
		switch (FlightUIController.speedDisplayMode)
		{ 
		this.SAS.setOn (FlightGlobals.ActiveVessel.ActionGroups [KSPActionGroup.SAS]);
		this.rcs.setOn (FlightGlobals.ActiveVessel.ActionGroups [KSPActionGroup.RCS]);
		this.stgPitch.setValue (FlightGlobals.ActiveVessel.ctrlState.pitch);
		this.stgYaw.setValue (FlightGlobals.ActiveVessel.ctrlState.yaw);
		this.stgRoll.setValue (FlightGlobals.ActiveVessel.ctrlState.roll);
		this.dockPitch.setValue (FlightGlobals.ActiveVessel.ctrlState.pitch);
		this.dockYaw.setValue (FlightGlobals.ActiveVessel.ctrlState.yaw);
		this.dockRoll.setValue (FlightGlobals.ActiveVessel.ctrlState.roll);
		this.linX.setValue (FlightGlobals.ActiveVessel.ctrlState.X);
		this.linY.setValue (FlightGlobals.ActiveVessel.ctrlState.Y);
		this.linZ.setValue (FlightGlobals.ActiveVessel.ctrlState.Z);
		this.atmos.setValue (FlightGlobals.getAtmDensity (FlightGlobals.getStaticPressure ()) / FlightGlobals.getAtmDensity ((double)((float)FlightGlobals.currentMainBody.staticPressureASL)) * 100000.0 + 1.0);
		this.stage.setValue ((double)Mathf.Clamp (Staging.CurrentStage, 0, Staging.lastStage));
		this.Lin.setOn (!InputBinding.linRotState);
		this.Rot.setOn (InputBinding.linRotState); 
		if (settings.Get<bool>("Orbital: Apoapsis Height")) GUILayout.Label(Tools.FormatSI(this.vessel.orbit.ApA, Tools.SIUnitType.Distance), dataStyle);
                if (settings.Get<bool>("Orbital: Periapsis Height")) GUILayout.Label(Tools.FormatSI(this.vessel.orbit.PeA, Tools.SIUnitType.Distance), dataStyle);
                if (settings.Get<bool>("Orbital: Time to Apoapsis")) GUILayout.Label(Tools.FormatTime(this.vessel.orbit.timeToAp), dataStyle);
                if (settings.Get<bool>("Orbital: Time to Periapsis")) GUILayout.Label(Tools.FormatTime(this.vessel.orbit.timeToPe), dataStyle);
            }
		
		
		*/
	
		public static void ReadFlightData() {
			if (FlightGlobals.ActiveVessel == null || !CCPConnector.connectedToCCP)
	    		return;
			actualUT = Planetarium.GetUniversalTime();
			nodesPresent = FlightGlobals.ActiveVessel.patchedConicSolver.maneuverNodes.Count > 0;
			if (nodesPresent) {
				actualTT = (actualUT -  FlightGlobals.ActiveVessel.patchedConicSolver.maneuverNodes[0].UT);	
				//this..maneuverNodes [0].GetBurnVector (FlightGlobals.ActiveVessel.orbit);
				
				dVForNode = FlightGlobals.ActiveVessel.patchedConicSolver.maneuverNodes[0].GetBurnVector (FlightGlobals.ActiveVessel.orbit).magnitude;
			}
			
			altitude = ""+ FlightGlobals.ActiveVessel.altitude;	
			// altitude could be full of values after the comma, will shorten it
			altitude = FTools.ShortenValue(altitude,0);
			
			ovSpeed = FlightGlobals.ActiveVessel.verticalSpeed;
			vSpeed = ovSpeed;
			if (vSpeed < -100)
				vSpeed = 0;
			else 
				vSpeed += 100;
			if (vSpeed > 200)
				vSpeed = 200;
			
			// inverting vSpeed clamped value for display reasons
			vSpeed = 200 -vSpeed;
			
			
			gees = FlightGlobals.ActiveVessel.geeForce;
			
			rcsStatus = FlightGlobals.ActiveVessel.ActionGroups [KSPActionGroup.RCS];
			
			if (rcsStatus == true)
				CCPConnector.SetCHValue(22,1,true);
			else
				CCPConnector.SetCHValue(22,0,true);
				
			CCPConnector.SetChValue(20,FTools.ShortenValue(""+ovSpeed,2)+"m/s",(int) Math.Round((double)vSpeed), (int)0,(int)200) ;
			CCPConnector.SetChValue(21,FTools.ShortenValue(""+gees,2)+"g",(int) Math.Round((double)gees*100), (int)0,(int)(50*100)) ;
			
			if (FlightGlobals.ActiveVessel.ctrlState.killRot)
				sasStatus = 1;
			else
				sasStatus = 0;
			
			if (flightInputHandler) {
				if (flightInputHandler.precisionMode)
					precisionModeStatus = 1;
				else
					precisionModeStatus = 0;	
				
				/*
				if (CCPConnector.debugMode)
					Debug.Log("flightInputHandler.precisionMode = " + flightInputHandler.precisionMode);
					*/
			}
			else {
				/*
				if (CCPConnector.debugMode) {
					Debug.Log("CCP NO flightInputHandler	!!");
				}
				*/
			}
			if (CCPConnector.debugMode && highLogic == null) {
				Debug.Log("CCP NO highLogic	!!");	
			}
			
			actualThrottle = FTools.ShortenValue(""+ (FlightGlobals.ActiveVessel.ctrlState.mainThrottle * 100),0)+"%";
			speed = GetSpeed();
			
			actualMissionTime = Vessel.GetMETString(FlightGlobals.ActiveVessel);
			actualTime = KSPUtil.PrintTime((int) Math.Abs(actualUT),3,true);
			timeToApo = KSPUtil.PrintTime((int) FlightGlobals.ActiveVessel.orbit.timeToAp,3,true);
			timeToPeri = KSPUtil.PrintTime((int) FlightGlobals.ActiveVessel.orbit.timeToPe,3,true);
			if (nodesPresent) {
				//timeToManouver =  KSPUtil.PrintTime((int) Math.Abs(actualTT),3,true);
				timeToManouver =  KSPUtil.PrintTime((int) actualTT,3,true);
				dvToNodeS = FTools.ShortenValue(""+dVForNode,2) + "m/s";
			}	
			else {
				timeToManouver = "No Manouver";
				dvToNodeS = " none...";
			}
			actualTimeWarp = "" + TimeWarp.CurrentRate + " X";
			if (sendInfoPanel) {
				if (CCPConnector.mainMessages[8].active == false)
					CCPConnector.mainMessages[8].active = true;
				switch(infoPanelIndex) {
					case 0 :
						infoPanelTitle = "Vessel";
						infoPanelSString = GetInfo(InfoType.Vessel);
					break;
					case 1 : 
						infoPanelTitle = "Resources";
						infoPanelSString = GetInfo(InfoType.Resources);
					break;
					case 2 :
						infoPanelTitle = "Orbit";
						infoPanelSString = GetInfo(InfoType.Orbit);
					break;
					case 3 :
						infoPanelTitle = "Body";
						infoPanelSString = GetInfo(InfoType.Body);
					break;
				}
				/*
				if (CCPConnector.debugMode)	
					Debug.Log(" infoPanelSString = " + infoPanelSString);
				*/	
			}
			else if (CCPConnector.mainMessages[8].active)
				CCPConnector.mainMessages[8].active = false;
			
			if (sendSeparateInfos) {
				CCPConnector.SetCHValue(10,GetInfo(InfoType.Vessel),true);
				CCPConnector.SetCHValue(11,GetInfo(InfoType.Orbit),true);
				CCPConnector.SetCHValue(12,GetInfo(InfoType.Body),true);
				CCPConnector.SetCHValue(28,GetInfo(InfoType.Resources),true);
				
			}
			else {
				CCPConnector.mainMessages[10].active = false;
				CCPConnector.mainMessages[11].active = false;
				CCPConnector.mainMessages[12].active = false;
			}
			if (CCPConnector.debugMode) {
				//Debug.Log("CCP   actualTime = " + actualTime + " actualMissionTime = " + actualMissionTime);	
			}
			
			CCPConnector.SetCHValue(0,altitude,true);
			CCPConnector.SetCHValue(1,actualTimeWarp,true);
			CCPConnector.SetCHValue(2,sasStatus,true);
			CCPConnector.SetCHValue(3,speed,true);
			CCPConnector.SetCHValue(4,actualThrottle,true);
			CCPConnector.SetCHValue(5,precisionModeStatus,true);
			CCPConnector.SetCHValue(6,actualMissionTime,true);
			CCPConnector.SetCHValue(7,actualTime,true);
			CCPConnector.SetCHValue(8,infoPanelSString,true);
			CCPConnector.SetCHValue(9,infoPanelTitle,true);
			CCPConnector.SetCHValue(23,timeToApo,true);
			CCPConnector.SetCHValue(24,timeToPeri,true);
			CCPConnector.SetCHValue(25,timeToManouver,true);
			CCPConnector.SetCHValue(29,dvToNodeS,true);
			CCPConnector.SetCHValue(30,FlightUIController.speedDisplayMode.ToString(),true);
		
		}
		
		public static string GetSpeed() {
			if (flightUIController != null)
				return  flightUIController.speed.text;
			
			switch (FlightUIController.speedDisplayMode)
			{
			case FlightUIController.SpeedDisplayModes.Orbit:

				{
					return  FlightGlobals.ship_obtSpeed.ToString();
				}
			case FlightUIController.SpeedDisplayModes.Surface:

				{
					return  FlightGlobals.ship_srfSpeed.ToString();
					
				}
			case FlightUIController.SpeedDisplayModes.Target:

				{
					return  FlightGlobals.ship_tgtSpeed.ToString();
					
				}
			}
			return "0";
		}
		
	//public enum InfoType{Vessel,Orbit,Body,Situation,Other, };	
		public static string GetInfo(InfoType type) {
			string result = "";
			switch (type) {
				case InfoType.Vessel : 
					//result += "\n\n";
					result += FlightGlobals.ActiveVessel.vesselName + "\n";
					Vector3 eul = FlightGlobals.ActiveVessel.srfRelRotation.eulerAngles;
					result += "Rot x : " + FTools.ShortenValue(""+eul.x,0)+ "\n Y : " +  FTools.ShortenValue(""+eul.y,0) + "\n Z : " +  FTools.ShortenValue(""+eul.z,0) +"\n";
					result += "V Speed : " + FTools.ShortenValue(""+ ovSpeed , 2) + " m/s\n\n";
					result += "Altitude : " + altitude + "m\n\n";
					result += FlightUIController.speedDisplayMode.ToString() + " : " + speed + "\n\n";
					result += "Throttle : " + actualThrottle + "\n\n";
					result += "G Force : " + FTools.ShortenValue("" + gees,2) + "\n\n";
					result += "Mass : " + FTools.ShortenValue(""+ FlightGlobals.ActiveVessel.GetTotalMass(),2) +"\n\n";
					//result += "G Force : " + FTools.ShortenValue(""+ FlightGlobals.ActiveVessel.geeForce,2)  +"\n";
				break;
				
				case InfoType.Resources : 
					result += "Liquid Fuel : " +FTools.ShortenValue("" +  fuel,2) + "\n";
					result += "Oxidizer  : " + FTools.ShortenValue("" + oxidizer,2) + "\n";
					result += "Solid Fuel  : " + FTools.ShortenValue(""+solidFuel,2) + "\n\n";
					result += "CURRENT active engines fuel\n"; 
					result += " Liquid Fuel : " +FTools.ShortenValue("" +  csLiquidFuel,2) + "\n";
					result += " Oxidizer  : " + FTools.ShortenValue("" + csOxidizer,2) + "\n\n";
					result += " Solid Fuel  : " + FTools.ShortenValue(""+csSolidFuel,2) + "\n\n";
					
					result += "Monopropellant : " +  FTools.ShortenValue("" + monoPropellant,2) +  "\n\n";
					result += "Battery charge : " +  FTools.ShortenValue(""+ePower,2) +  "\n\n";
					result += "Air Intake : " + FTools.ShortenValue(""+ airIntake,2) + "\n\n";
					
				
				break;
				case InfoType.Orbit : 
				//	result += "\n\n";
					Orbit orb = FlightGlobals.ActiveVessel.GetOrbit();
					result += "ApA : " + FTools.ShortenValue(""+ orb.ApA,0) +"\n";
					//result += "ApR : " + ShortenValue(""+ orb.ApR,0) +"\n";
					result += "PeA : " + FTools.ShortenValue(""+ orb.PeA,0) +"\n";
					//result += "PeR : " + ShortenValue(""+ orb.PeR,0) +"\n";
					result += "Eccntr : " + FTools.ShortenValue(""+orb.eccentricity,2)+"\n";
					result += "Incln : " + FTools.ShortenValue(""+orb.inclination,2)+"\n";
					result += "T to Apo  " + KSPUtil.PrintTime((int) Math.Abs(orb.timeToAp),3,true)+"\n";
					result += "T to Peri  " + KSPUtil.PrintTime((int) Math.Abs(orb.timeToPe),3,true)+"\n\n";
					if (nodesPresent) {
						result += "Next Node : " + KSPUtil.PrintTime((int) Math.Abs(actualTT),3,true)+"\n";
						result +="DV : " +  dvToNodeS + "\n";
					}
				break;
				case InfoType.Body : 
					//result += "\n\n";
					//result += "No info yet \n but should come...";
					result +=""	+ FlightGlobals.ActiveVessel.mainBody.bodyName +"\n";
					result +="G: "	+ FlightGlobals.ActiveVessel.mainBody.GeeASL +"\n";
					result +="Radius: "	+ FlightGlobals.ActiveVessel.mainBody.Radius +"\n";
					result +="Mass: "	+ FlightGlobals.ActiveVessel.mainBody.Mass +"\n";
					result += "Description : \n";
					result += "" + FlightGlobals.ActiveVessel.mainBody.bodyDescription;
				break;///
					
			}
			if (result.Length > 511)
				result = result.Substring(0,511);
			return result;	
			
		}
		
		
	}
}

